Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
ParamTextureImage Class Reference

A class object for storing a pointer to a Texture along with a set of properties that indicates which image to bind to a shader input. More...

`#include "paramTexture.h"`

Inheritance diagram for ParamTextureImage:

## Public Member Functions
| ParamTextureImage (Texture *tex, bool read, bool write, int z=-1, int n=0)
| Creates a new ParamTextureImage storing the given texture and image binding parameters.
virtual int | complete_pointers (TypedWritable **plist, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
virtual TypeHandle | force_init_type ()
int | get_bind_layer () const
bool | get_bind_layered () const
int | get_bind_level () const
Texture * | get_texture () const
virtual TypeHandle | get_type () const
virtual TypeHandle | get_value_type () const
| Returns Texture::get_class_type(), even though it technically stores more than just a Texture.
bool | has_read_access () const
bool | has_write_access () const
virtual void | output (std::ostream &out) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type ParamValue.
Static Public Member Functions inherited from ParamValueBase
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_bind_layer
| Returns the image layer that should be bound.
| get_bind_layered
| Returns true if all layers of this image should be bound simultaneously.
| get_bind_level
| Returns the image level that should be bound.
| get_texture
| Retrieves the texture stored in the parameter.
| has_read_access
| Returns true if this image should be bound with read access enabled.
| has_write_access
| Returns true if this image should be bound with write access enabled.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

A class object for storing a pointer to a Texture along with a set of properties that indicates which image to bind to a shader input.

This class is useful for binding texture images to a shader, which is a fairly esoteric feature.

Definition at line 81 of file paramTexture.h.

## Constructor & Destructor Documentation

## ◆ ParamTextureImage()

ParamTextureImage::ParamTextureImage | ( | Texture * | tex,
|  | bool | read,
|  | bool | write,
|  | int | z = -1,
|  | int | n = 0 )
| inline

Creates a new ParamTextureImage storing the given texture and image binding parameters.

Definition at line 54 of file paramTexture.I.

## Member Function Documentation

## ◆ complete_pointers()

int ParamTextureImage::complete_pointers | ( | TypedWritable ** | p_list,
|  | BamReader * | manager )
| virtual

Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().

Returns the number of pointers processed.

Reimplemented from TypedWritable.

Definition at line 152 of file paramTexture.cxx.

References TypedWritable::complete_pointers().

## ◆ force_init_type()

virtual TypeHandle ParamTextureImage::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from ParamValueBase.

Definition at line 131 of file paramTexture.h.

## ◆ get_class_type()

static TypeHandle ParamTextureImage::get_class_type | ( |  | ) |
| inline static

Definition at line 132 of file paramTexture.h.

## ◆ get_type()

virtual TypeHandle ParamTextureImage::get_type | ( |  | ) | const
| inline virtual

Reimplemented from ParamValueBase.

Definition at line 128 of file paramTexture.h.

## ◆ get_value_type()

TypeHandle ParamTextureImage::get_value_type | ( |  | ) | const
| inline virtual

Returns Texture::get_class_type(), even though it technically stores more than just a Texture.

Reimplemented from ParamValueBase.

Definition at line 77 of file paramTexture.I.

## ◆ init_type()

static void ParamTextureImage::init_type | ( |  | ) |
| inline static

Definition at line 135 of file paramTexture.h.

## ◆ output()

void ParamTextureImage::output | ( | std::ostream & | out | ) | const
| virtual

Implements ParamValueBase.

Definition at line 98 of file paramTexture.cxx.

## ◆ register_with_read_factory()

void ParamTextureImage::register_with_read_factory | ( |  | ) |
| static

Tells the BamReader how to create objects of type ParamValue.

Definition at line 130 of file paramTexture.cxx.

References BamReader::get_factory(), and Factory< Type >::register_factory().

## ◆ write_datagram()

void ParamTextureImage::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg )
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from TypedWritable.

Definition at line 139 of file paramTexture.cxx.

References Datagram::add_int32(), Datagram::add_int8(), Datagram::add_uint8(), TypedWritable::write_datagram(), and BamWriter::write_pointer().

## Member Data Documentation

## ◆ get_bind_layer

int ParamTextureImage::get_bind_layer
| inline

Returns the image layer that should be bound.

This is undefined if get_bind_layered() returns false.

Definition at line 107 of file paramTexture.h.

## ◆ get_bind_layered

bool ParamTextureImage::get_bind_layered
| inline

Returns true if all layers of this image should be bound simultaneously.

Definition at line 107 of file paramTexture.h.

## ◆ get_bind_level

int ParamTextureImage::get_bind_level
| inline

Returns the image level that should be bound.

Definition at line 106 of file paramTexture.h.

## ◆ get_texture

Texture * ParamTextureImage::get_texture
| inline

Retrieves the texture stored in the parameter.

Definition at line 103 of file paramTexture.h.

## ◆ has_read_access

bool ParamTextureImage::has_read_access
| inline

Returns true if this image should be bound with read access enabled.

Definition at line 104 of file paramTexture.h.

## ◆ has_write_access

bool ParamTextureImage::has_write_access
| inline

Returns true if this image should be bound with write access enabled.

Definition at line 105 of file paramTexture.h.

The documentation for this class was generated from the following files:

- panda/src/gobj/paramTexture.h
- panda/src/gobj/paramTexture.cxx
- panda/src/gobj/paramTexture.I